/*
 *@(#)AuctionSeller.java	1.3 02/05/22

Copyright 2002 Sun Microsystems, Inc. All Rights Reserved. 

Redistribution and use in source and binary forms, with or without modification, are
permitted provided that the following conditions are met: 

Redistribution of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.

Redistribution in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other
materials provided with the distribution. 

Neither the name of Sun Microsystems, Inc. or the names of contributors may be used to
endorse or promote products derived from this software without specific prior written
permission. 

This software is provided "AS IS," without a warranty of any kind. ALL EXPRESS OR
IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY IMPLIED
WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN MICROSYSTEMS, INC. ("SUN") AND ITS
LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A
RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
IN NO EVENT WILL SUN OR ITS LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT
OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR
PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,
ARISING OUT OF THE USE OF OR INABILITY TO USE THIS SOFTWARE, EVEN IF SUN HAS
BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. 

You acknowledge that this software is not designed, licensed or intended for use in the
design, construction, operation or maintenance of any nuclear facility. 
 
 */

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.io.*;
import java.io.*;
import java.util.Vector;
import org.kxml.*;
import org.kxml.parser.*;

/**
 * An example MIDlet with simple "Hello" text and an Exit command.
 * Refer to the startApp, pauseApp, and destroyApp
 * methods so see how each handles the requested transition.
 */
public class AuctionSeller extends MIDlet implements CommandListener {

    /*
	 *	 MIDlet objects
	 */ 
	 private Command exitCommand; // The exit command
	 private Command xmlCommand;
	 private Command detailCommand;
	 private Command bidCommand;
	 private Command backCommand;
	 private Command submitCommand;
	 private Command cancelCommand;
    private Display display;	// The display for this MIDlet
	 private List _auctionList;
	 private Form _detailForm;
	 private Form _bidForm;
	 private Form _successForm;
	 private Form _mainForm;
	 private TextField _priceTextField;
	 private TextField _emailTextField;


	 private final static String AUCTIONLIST_TAG = "AUCTION-LIST";
	 private final static String AUCTIONREQUEST_TAG = "AUCTION-REQUEST";
	 private final static String SERVLET_URL =
		  "http://127.0.0.1:8080/bidder/bidder";
	 public static boolean COMPLETED = false;
	 public final static String EMPTY_VALUE_STRING = "\"\"";
	 public static Vector nameValueList;
	 public static Vector productList;
	 public static int numProducts = 0;
	 public static boolean _isNoProduct = false;
	 public static String tagName = new String();
	 public static String tagValue = new String();
	 public final static int NUM_OF_XML_TAGS = 7;

    public AuctionSeller() {

		  // Create an instance of Display Manager
        display = Display.getDisplay(this);

		  // Create the required Command Objects
	     exitCommand = new Command("Exit", Command.EXIT, 2);
		  backCommand = new Command( "Back", Command.BACK, 2 );
		  xmlCommand  = new Command( "Auction", Command.SCREEN, 1 );
		  bidCommand  = new Command( "Bid", Command.SCREEN, 3 );

		  detailCommand = new Command( "Detail", Command.SCREEN, 3 );
		  submitCommand = new Command( "Submit", Command.SCREEN, 3 );
		  cancelCommand = new Command( "Cancel", Command.CANCEL, 3 );
		  nameValueList = new Vector();
		  
		  productList = new Vector();
    }

    /**
     * Start up the Hello MIDlet by creating the TextBox and associating
     * the exit command and listener.
     */
    public void startApp() {

		  _auctionList = new List( "Products", List.IMPLICIT );
		  _detailForm  = new Form( "AuctionDetails" );
		  _bidForm     = new Form( "Bids" );
		  _successForm = new Form( "Results" );

		  _mainForm = new Form( "Auction Bidder" );
		  _mainForm.append( "Please click on 'Auction' Button to look for products in auction" );

		  _priceTextField = new TextField( "Enter New Price: ", "", 8, TextField.NUMERIC );
		  _emailTextField = new TextField( "Enter Email ", " ", 255, TextField.EMAILADDR );


		  _auctionList.addCommand( exitCommand );
		  _auctionList.addCommand( bidCommand );
		  _auctionList.addCommand( detailCommand );
		  _auctionList.setCommandListener( this );

		  _detailForm.addCommand( bidCommand );
		  _detailForm.addCommand( exitCommand );
		  _detailForm.setCommandListener( this );

		  _bidForm.addCommand( submitCommand );
		  _bidForm.addCommand( cancelCommand );
		  _bidForm.setCommandListener( this );

		  _successForm.addCommand( exitCommand );
		  _successForm.setCommandListener( this );
        

		  _mainForm.addCommand( exitCommand );
		  _mainForm.addCommand( xmlCommand );
		  _mainForm.setCommandListener( this );


        display.setCurrent( _mainForm );
    }

    /**
     * Pause is a no-op since there are no background activities or
     * record stores that need to be closed.
     */
    public void pauseApp() {
    }

    /**
     * Destroy must cleanup everything not handled by the garbage collector.
     * In this case there is nothing to cleanup.
     */
    public void destroyApp(boolean unconditional) {
    }

    /**
	  *
     * Traverses the XML file
	  * @param : XMlParser an instance of the kxml parser
	  * @param : String for pretty printing
	  *
     */
    
	 public static void traverse (XmlParser parser, String indent) 
			throws IOException {
    
	 boolean leave = false;

	 // Parse the XML tags in a loop 
	  do {
	    ParseEvent event = parser.read ();

	    switch (event.getType ()) {
	    case Xml.START_TAG:

		// see API doc of StartTag for more access methods

		String name = event.getName();
		tagName = new String( name );
			 // If the Start Tag is <Auctionlist> or <AuctionRequest>
			 // we skip...
			 if ( !( name.compareTo(AUCTIONLIST_TAG) == 0 || 
					name.compareTo( AUCTIONREQUEST_TAG ) == 0 ) )
			 {
				 if ( ! COMPLETED ) {
					 traverse (parser, indent + "."); // recursion
				 }
			 }
		break;
		
	    case Xml.END_TAG:
		break;

	    case Xml.END_DOCUMENT:
		leave = true;
		break;
		
		 case Xml.TEXT:
		String text = event.getText();
		tagValue = new String( text );
		if ( text.trim().compareTo( EMPTY_VALUE_STRING ) == 0 ) {
			System.out.println( "No products to bid on..." );
			_isNoProduct = true;
			COMPLETED = true;
			leave = true;
		}					 
		else {
			System.out.println (indent + " name: " + tagName + "text: "+ text );
			nameValueList.addElement( tagName );
			nameValueList.addElement( text );
			if ( tagName.equals( "product" ) ) {
				numProducts++;
				productList.addElement( text );
			}

		}
		break;

	    case Xml.WHITESPACE:
		break;

	    default:
		System.out.println 
		    (indent + "ignoring some other (legacy) event: "+event);
	    }
	}
	while (!leave);
    }



    /**
	  *
     * @Name  : submitData
	  *        : This method is called as part of MIDlet sending data to the Servlet
	  *        : The data to be submitted is contained in the parameters
	  * @param : String email 
	  * @param : String newPrice
	  * @param : String product
	  *
     */
	 public boolean submitData ( String email,
										  String newPrice,
										  String product ) throws IOException {
		 HttpConnection conn = null;
		 InputStream is = null;
		 OutputStream os = null;
		 StringBuffer buffer = new StringBuffer();
		 String emailParam = "email " + email;
		 String priceParam = "price " + newPrice;
		 String productParam = "product " + product;
		 String resultString = null;

		 try
		 {
			 conn = (HttpConnection)Connector.open(SERVLET_URL);
			 System.out.println( "Opened a HttpConnection to: " + SERVLET_URL );
	 
			 /*  Send the parameters to the servlet via POST method  */
			 conn.setRequestMethod( HttpConnection.POST );
			 conn.setRequestProperty( "email", email );
			 conn.setRequestProperty( "price", newPrice );
			 conn.setRequestProperty( "product", product );
			 os = conn.openOutputStream();
			 os.write( emailParam.getBytes() );
			 os.write( priceParam.getBytes() );
			 os.write( productParam.getBytes() );
			 os.flush();
	 
			 is = conn.openDataInputStream();
			 int ch;
	 
			 while ((ch = is.read()) != -1)
				buffer.append((char)ch);
	 
			 resultString = buffer.toString();
			 
			 /*  Ensure that we tidy everything up  */
			 if (is != null)
				is.close();
	  
			 if (conn != null)
				conn.close();
	 
			 if (os != null)
				os.close();
			 
			  System.out.println( "results are: " + resultString );
			  return ( resultString.equals( "TRUE" ) || resultString.equals( "true" ) );

		 }
		 catch( IOException e )
		 {
			 e.printStackTrace();
			 if (conn != null)
				conn.close();
	 
			 if (os != null)
				os.close();
			 if ( is != null )
				 is.close();
			 return false;

		 }
		 finally
		 {
			 if (conn != null)
				conn.close();
	 
			 if (os != null)
				os.close();
			 if ( is != null )
				 is.close();
			 return true;

		 }
	 }




    /**
	  *
     * @Name  : getXML()
	  *        : Called as part of the HTTP.GET
	  * @return: String representation of the XML data obtained from the Servlet
	  * @param : 
	  *
     */
	 public String getXML() throws IOException
	 {
		 HttpConnection conn = null;
		 InputStream servletStream = null;
		 OutputStream os = null;
		 StringBuffer xmlBuffer = new StringBuffer();
		 String xmlString = null;
	
		 try {						  
			conn = (HttpConnection)Connector.open(SERVLET_URL);
			System.out.println( "Opened a HttpConnection to: " + SERVLET_URL );
	
			/*  Send the parameters to the servlet via GET method  */
			conn.setRequestMethod( HttpConnection.GET );
			os = conn.openOutputStream();
			os.flush();
	
			servletStream = conn.openDataInputStream();
			int ch;
	
			while ((ch = servletStream.read()) != -1)
			  xmlBuffer.append((char)ch);
	
			xmlString = xmlBuffer.toString();
			
			/*  Ensure that we tidy everything up  */
			if (servletStream != null)
			  servletStream.close();
	 
			if (conn != null)
			  conn.close();
	
			if (os != null)
			  os.close();
			
			 System.out.println( "Instructions are: " + xmlString );
			 return xmlString;

		 } catch (IOException e) {
			System.out.println("IO error getting xmlString from server");
			/*  Ensure that we tidy everything up  */
			if (servletStream != null)
			  servletStream.close();
	 
			if (conn != null)
			  conn.close();
	
			if (os != null)
			  os.close();
			return null;
		 } finally {
			 System.out.println( "In finally..." );
			/*  Ensure that we tidy everything up  */
			if (servletStream != null)
			  servletStream.close();
	 
			if (conn != null)
			  conn.close();
	
			if (os != null)
			  os.close();
		   return xmlString;
	 }
  
  }

  /*
	* Respond to commands, including exit
	* On the exit command, cleanup and notify that the MIDlet has been destroyed.
	*/
  public void commandAction(Command c, Displayable s) {
    if (c == exitCommand) {
		nameValueList.removeAllElements();
		productList.removeAllElements();
		numProducts = 0;
		_isNoProduct = false;
	   destroyApp(false);
	   notifyDestroyed();
    }	
    else if ( c == xmlCommand ) {
	    try
	    {
			 String xmlString = getXML();
			 byte[] xmlByteArray = xmlString.getBytes();
			 ByteArrayInputStream xmlStream = new ByteArrayInputStream(xmlByteArray);
			 InputStreamReader xmlReader = new InputStreamReader(xmlStream);
			 XmlParser parser = new XmlParser(xmlReader);
			 traverse( parser, "" );
			 if ( _isNoProduct ) {
	
				 _mainForm.removeCommand( xmlCommand );
				 _mainForm.delete( 0 );
				 _mainForm.append( "No products in Auction.  Exit and Try again" );

			 }
			 else {
				 System.out.println( "You have " + numProducts + " products in Auction.." );
				 for ( int i = 0 ;i<numProducts; ++i ) {
					 String prodName = (String)productList.elementAt( i );
					 System.out.println( " Product no: " + i + " is, " + prodName );
					 _auctionList.append( prodName, null );
					 System.out.println( "appended to _auctionList" );
				 }
				 System.out.println( "gonna setcurrent on _auctionList.." );
				 display.setCurrent( _auctionList );

			 }
	    }
		 catch( Exception e )
		 {
			 e.printStackTrace();
		 }

    }
	 else if ( c == bidCommand ) {  // Ready to Submit data
		 String prodName =  _auctionList.getString( _auctionList.getSelectedIndex() );
		 System.out.println( " bid posted for product " + prodName );
		 _bidForm.setTitle( prodName );
		 _bidForm.append( "Current" );
		 _bidForm.append( "Increment" );
		 _bidForm.append( _priceTextField );
		 _bidForm.append( _emailTextField );
		 display.setCurrent( _bidForm );

	 }
	 else if ( c == cancelCommand ) {
		 display.setCurrent( _detailForm );  
	 }
	 else if ( c == submitCommand ) {
		 System.out.println( "Bid submit requested..." );
		 String product = _bidForm.getTitle();
		 String price   = _priceTextField.getString();
		 String email   = _emailTextField.getString();
		 System.out.println( " product is: " + product );
		 System.out.println( " New price is " + price  );
		 System.out.println( " Email address is: " + email );
		 try
		 {
			 boolean ok = submitData( email, price, product );
			 _successForm.setTitle( product );
			 if ( ok ) {
				 _successForm.append( "Bid submission SUCCESSFUL" );
			 }
			 else { 
				 _successForm.append( "Bid submission FAILED" );
		    }

			 display.setCurrent( _successForm );

		 }
		 catch( Exception e )
		 {
			 System.out.println( "Error in Submitting bids.." );
			 e.printStackTrace();
		 }
	 }
	 else if ( c == detailCommand ) {
		 String prodName = _auctionList.getString( _auctionList.getSelectedIndex() );
		 System.out.println( " details requested for product " + prodName );

		 int offset = 0;

		 for ( int i = 0; i < productList.size(); ++i ) {
			 String element = ( String )productList.elementAt( i );
			 System.out.println( "element is: " + element + "prodName is: " + prodName );
			 if ( element.equals( prodName ) ) {
				 
				 offset = i;
				 break;
			 }
		 }

		 System.out.println( "size of nameValueList " + nameValueList.size() );
		 System.out.println( "offset is: " + offset );
		 for ( int i = offset * ( 2 * NUM_OF_XML_TAGS ) ; 
			   i < (offset+1)* (2 * NUM_OF_XML_TAGS) - 1 && i < nameValueList.size() ; i+=2 ) {
			 String element = ( String ) nameValueList.elementAt( i );
			 String value   = ( String ) nameValueList.elementAt( i+1 );
			 System.out.println( element + " = " + value );

			 if ( element.equals( "product" ) ) {
				 _detailForm.setTitle( value );
			 }
			 else {
				 if ( element.equals( "auction-topic" ) ) {
					 _detailForm.append( "auction-name" );
				 }
				 else
				 {
					 _detailForm.append( element );
				 }
				 _detailForm.append( "\n" );
				 _detailForm.append( value );
				 _detailForm.append( "\n" );

			 }

		 }
		 display.setCurrent( _detailForm );
	 }
  }


}

