/**
 *  Sample Servlet to test with Sample MIDlet
 *	 The servlet portion
 
Copyright 2002 Sun Microsystems, Inc. All Rights Reserved. 

Redistribution and use in source and binary forms, with or without modification, are
permitted provided that the following conditions are met: 

Redistribution of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.

Redistribution in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other
materials provided with the distribution. 

Neither the name of Sun Microsystems, Inc. or the names of contributors may be used to
endorse or promote products derived from this software without specific prior written
permission. 

This software is provided "AS IS," without a warranty of any kind. ALL EXPRESS OR
IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY IMPLIED
WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN MICROSYSTEMS, INC. ("SUN") AND ITS
LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A
RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
IN NO EVENT WILL SUN OR ITS LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT
OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR
PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,
ARISING OUT OF THE USE OF OR INABILITY TO USE THIS SOFTWARE, EVEN IF SUN HAS
BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. 

You acknowledge that this software is not designed, licensed or intended for use in the
design, construction, operation or maintenance of any nuclear facility. 

 
 *
 * @author Srikanth Raju
 **/

import java.util.Enumeration;
import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class ServletXML extends HttpServlet {

  /**
   *  Initialise the servlet.  Simply create an instance of the Mapper
   *  object that can then be used for calls to the servlet.
   *
   * @exception ServletException if a servlet error occurs
   **/
  public void init() throws ServletException {
	  System.out.println( "In ServletXML::init()" );
  }

  /**
   *  Respond to a GET request from the client.  To simplify life we 
   *  simply pass this to the doPost method since that will be the preferred
   *  way of calling the servlet
   *
   * @param request The servlet request we are processing
   * @param response The servlet response to be generated
   * @exception IOException if an I/O error occurs
   * @exception ServletException if a servlet error occurs
   **/
  public void doGet(HttpServletRequest request, HttpServletResponse response)
      throws IOException, ServletException {
    System.out.println("Got a GET");
    Enumeration e;

    for (e = request.getAttributeNames(); e.hasMoreElements();)
      System.out.println("ATTR = " + e.nextElement());

    for (e = request.getParameterNames(); e.hasMoreElements();)
      System.out.println("PARAM = " + e.nextElement());

    System.out.println("Displayed parameters");

    response.setContentType("text/html");
    PrintWriter out = response.getWriter();

	 generateXML( out );

  }

  /**
   *  Respond to a POST request from the client.  
   *
   * @param request The servlet request we are processing
   * @param response The servlet response to be generated
   * @exception IOException if an I/O error occurs
   * @exception ServletException if a servlet error occurs
   **/
  public void doPost(HttpServletRequest request, HttpServletResponse response)
      throws IOException, ServletException {
	 System.out.println( "In doPost... " );
    String ticker = request.getParameter("Ticker");
    String price = request.getParameter("price");
    String company = request.getParameter("Company");
    System.out.println("Got a POST: Ticker = " + ticker + ", New price = " +
      price + " Company Name = " + company );

    Enumeration pE;

	 System.out.println( "getHeaderNames()..." );
	 for ( pE = request.getHeaderNames(); pE.hasMoreElements(); ) {
		 System.out.println( "HEADER = " + pE.nextElement() );
	 }

	 ticker = request.getHeader( "ticker" );
	 price = request.getHeader( "price" );
	 company = request.getHeader( "company" );
	 System.out.println( " Ticker = " + ticker + ", Price = " + price + ", Company = " + company );
    System.out.println("Displayed parameters");

    response.setContentType("text/html");
    PrintWriter out = response.getWriter();

    //  Processing is simply a call to with
    //  appropriate parameters. For now return TRUE
	 out.println( "true" );
	 System.out.println( " HTTP Post returned True...!!" );
  }

  private void generateXML( PrintWriter out ) throws IOException
  {
	  out.println("<?xml vesion=\"1.0\"?>");
	  out.println("<QUOTELIST>");
	  out.println("<STOCKQUOTE>");
	  out.println("<ticker>SUNW</ticker>");
	  out.println("<price>20.0</price>");
	  out.println("<company>Sun Microsystems, Inc</company>");
	  out.println("<date-open>April 1981</date-open>");
	  out.println("<recommendation>Highly Recommended</recommendation>");
	  out.println("</STOCKQUOTE>");

	  out.println("<STOCKQUOTE>");
	  out.println("<ticker>NOK</ticker>");
	  out.println("<price>35</price>");
	  out.println("<company>Nokia Systems</company>");
	  out.println("<date-open>November 191</date-open>");
	  out.println("<recommendation>Recommended</recommendation>");
	  out.println("</STOCKQUOTE>");

	  out.println( "</QUOTELIST>");

	  System.out.println("<?xml vesion=\"1.0\"?>");
	  System.out.println("<QUOTELIST>");
	  System.out.println("<STOCKQUOTE>");
	  System.out.println("<ticker>SUNW</ticker>");
	  System.out.println("<price>20.0</price>");
	  System.out.println("<company>Sun Microsystems, Inc</company>");
	  System.out.println("<date-open>April 1981</date-open>");
	  System.out.println("<recommendation>Highly Recommended</recommendation>");
	  System.out.println("</STOCKQUOTE>");

	  System.out.println("<STOCKQUOTE>");
	  System.out.println("<ticker>NOK</ticker>");
	  System.out.println("<price>35</price>");
	  System.out.println("<company>Nokia Systems</company>");
	  System.out.println("<date-open>November 191</date-open>");
	  System.out.println("<recommendation>Recommended</recommendation>");
	  System.out.println("</STOCKQUOTE>");

	  System.out.println("</QUOTELIST>");


  }

}
